#include<bits/stdc++.h>
#define ll long LONG_MAX
#define MAXN 300007
using namespace std;
int a[MAXN];
int b1[MAXN],b2[MAXN];
void solve12(int n)
{
    vector<int>dvice;

    for(int i=0;i<n;i++)
    {
        if(a[i]==2) dvice.push_back(i);
    }
    if(a[0]==1)b1[0]=-1;
    else b1[0]=0;
    for(int i=1;i<n;i++)
    {
        if(a[i]==2)
        {
            if(a[i-1]==1) b1[i]=i;
            else b1[i]=b1[i-1];
        }
        else b1[i]=-1;
    }
    b1[0]=0;
    b1[1]=0;
    for(int i=2;i<n;i++)
    {
        if(a[i]==1)
        {
            int t=lower_bound(dvice.begin(),dvice.end(),i)-dvice.begin();
            if(t==0 || t==1) b2[i]=0;
            else b2[i]=dvice[t-2]+1;
        }
        else
        {
            int j=b1[a[i]];
            if(j==0) b2[i]=0;
            else
            {
                j--;
                int t=lower_bound(dvice.begin(),dvice.end(),j)-dvice.begin();
                if(t==0 || t==1) b2[i]=0;
                else b2[i]=dvice[t-2]+1;
            }
        }
    }
    int q;
    cin>>q;
    while(q--)
    {
        int l,r;
        cin>>l>>r;
        l--;r--;
        if(l>=b2[r]) cout<<"DA"<<endl;
        else cout<<"NE"<<endl;
    }
}
int main()
{
    ios_base::sync_with_stdio();
    cin.tie(0);cout.tie(0);
    int n;
    cin>>n;
    int cnt;
    for(int i=0;i<n;i++)
    {
        cin>>a[i];
        if(a[i]==1 || a[i]==2) cnt++;
    }
    if(cnt==n)
    {
        solve12(n);
        return 0;
    }
    b1[0]=0;
    for(int i=1;i<n;i++)
    {
        if(a[i-1]<=a[i]) b1[i]=b1[i-1];
        else b1[i]=i;
    }
    b2[0]=0;
    b2[1]=0;
    for(int i=2;i<n;i++)
    {
        if(a[i-1]<=a[i]) b2[i]=b2[i-1];
        else
        {
            b2[i]=b1[i-1];
            if(a[i-2]<=a[i]) b2[i]=max(b2[i],b1[i-2]);
        }
    }
    int q;
    cin>>q;
    while(q--)
    {
        int l,r;
        cin>>l>>r;
        l--;r--;
        if(l>=b2[r]) cout<<"DA"<<endl;
        else cout<<"NE"<<endl;
    }
}